RestSchemaValidator::NullRestSchemaValidator Class Reference

null REST validator; no schema is used but default serialization and deserialization is performed More...

Inheritance diagram for RestSchemaValidator::NullRestSchemaValidator:
[legend]

## Public Member Functions

| setBasePathImpl (string basePath)
| overrides the basePath value More...
Public Member Functions inherited from RestSchemaValidator::AbstractRestSchemaValidator
string | getBasePath ()
| returns the base path prefix for all requests in this schema More...
hash< RestExampleRequestInfo > | getExampleRequest (string method, string path, *softlist< string > content_types)
| returns a hash of example message information for the given request More...
hash< RestExampleResponseInfo > | getExampleResponse (string method, string path, int code, *softlist< string > content_types)
| returns a hash of example message information for the given request More...
hash< string, list< string > > | getPathOperationHash ()
| returns a hash of URI paths as keys with values as lists of supported HTTP methods More...
hash< RestQoreExampleCodeInfo > | getQoreExampleRequest (string method, string path)
| returns a hash of example Qore code for the given request More...
hash< RestQoreExampleCodeInfo > | getQoreExampleResponse (string method, string path, int code)
| returns example Qore code for the given response More...
string | getTargetUrl ()
| returns the target URL for the schema More...
hash< RestRequestServerInfo > | parseRequest (string method, string path, *data http_body, reference< hash > headers)
| processes and parses a client request and returns the deserialized message body (if any) More...
hash< RestResponseClientInfo > | parseResponse (string method, string path, int code, *data response_body, hash hdr)
| parses and validates the response from the server and returns a hash of the processed info More...
hash< RestRequestClientInfo > | processRequest (string method, string path, auto body, *hash headers, *softlist< string > content_types)
| processes a client-side REST request and returns a hash that can be used to make the outgoing client-side HTTP request More...
hash< HttpResponseInfo > | processResponse (string method, string path, int code, auto response_body, *hash headers, *softlist< string > content_types)
| processes a REST response with a serialized message body, validates any response data against schema definitions if possible More...
| setBasePath (string basePath)
| overrides the basePath value More...

## Public Attributes

const | DataDeserializationSupport
| Data deserialization support MIME types to codes and de/serialization functions.
const | DataSerializationSupport
| Data serialization support mapping codes to MIME types and de/serialization functions.

## Private Member Functions

string | getBasePathImpl ()
| returns the base path prefix for all requests in this schema More...
hash< RestExampleRequestInfo > | getExampleRequestImpl (string method, string path, *softlist< string > content_types)
| returns a hash of example message information for the given request More...
hash< RestExampleResponseInfo > | getExampleResponseImpl (string method, string path, int code, *softlist< string > content_types)
| returns a hash of example message information for the given request More...
hash< string, list< string > > | getPathOperationHashImpl ()
| returns a hash of URI paths as keys with values as lists of supported HTTP methods More...
hash< RestQoreExampleCodeInfo > | getQoreExampleRequestImpl (string method, string path)
| returns a hash of example Qore code for the given request More...
hash< RestQoreExampleCodeInfo > | getQoreExampleResponseImpl (string method, string path, int code)
| returns example Qore code for the given response More...
string | getTargetUrlImpl ()
| returns the target URL for the schema More...
hash< RestRequestServerInfo > | parseRequestImpl (string method, string path, *data http_body, reference< hash > headers)
| processes and parses a client request and returns the deserialized message body (if any) More...
hash< RestResponseClientInfo > | parseResponseImpl (string method, string path, int code, *data response_body, hash hdr)
| parses and validates the response from the server and returns a hash of the processed info More...
hash< RestRequestClientInfo > | processRequestImpl (string method, string path, auto body, *hash headers, *softlist< string > content_types)
| processes a client-side REST request and returns a hash that can be used to make the outgoing client-side HTTP request More...
hash< HttpResponseInfo > | processResponseImpl (string method, string path, int code, auto response_body, *hash headers, *softlist< string > content_types)
| processes a REST response with a serialized message body, validates any response data against schema definitions if possible More...

## Detailed Description

null REST validator; no schema is used but default serialization and deserialization is performed

## Member Function Documentation

## getBasePathImpl()

string RestSchemaValidator::NullRestSchemaValidator::getBasePathImpl | ( |  | ) |

privatevirtual

returns the base path prefix for all requests in this schema

Returns
  the base path prefix for all requests in this schema

Implements RestSchemaValidator::AbstractRestSchemaValidator.

## getExampleRequestImpl()

hash<RestExampleRequestInfo> RestSchemaValidator::NullRestSchemaValidator::getExampleRequestImpl | ( | string | method,
|  | string | path,
|  | *softlist< string > | content_types
| ) |  |

privatevirtual

returns a hash of example message information for the given request

Parameters

  method | the HTTP method (case insensitive)
  path | the URI path of the request
  content_types | the desired MIME types for serialization in order of preference; if none are usable then an exception is thrown

Returns
  a RestExampleRequestInfo of example message information for the given request

Implements RestSchemaValidator::AbstractRestSchemaValidator.

## getExampleResponseImpl()

hash<RestExampleResponseInfo> RestSchemaValidator::NullRestSchemaValidator::getExampleResponseImpl | ( | string | method,
|  | string | path,
|  | int | code,
|  | *softlist< string > | content_types
| ) |  |

privatevirtual

returns a hash of example message information for the given request

Parameters

  method | the HTTP method of the original request (case insensitive)
  path | the URI path of the original request
  code | the HTTP response code of the response
  content_types | the desired MIME types for serialization in order of preference; if none are usable then an exception is thrown

Returns
  a RestExampleResponseInfo hash giving example response message info

Implements RestSchemaValidator::AbstractRestSchemaValidator.

## getPathOperationHashImpl()

hash<string, list<string> > RestSchemaValidator::NullRestSchemaValidator::getPathOperationHashImpl | ( |  | ) |

privatevirtual

returns a hash of URI paths as keys with values as lists of supported HTTP methods

Returns
  a hash of URI paths as keys with values as lists of supported HTTP methods

Implements RestSchemaValidator::AbstractRestSchemaValidator.

## getQoreExampleRequestImpl()

hash<RestQoreExampleCodeInfo> RestSchemaValidator::NullRestSchemaValidator::getQoreExampleRequestImpl | ( | string | method,
|  | string | path
| ) |  |

privatevirtual

returns a hash of example Qore code for the given request

Parameters

  method | the HTTP method (case insensitive)
  path | the URI path of the request

Returns
  a RestQoreExampleCodeInfo hash giving example Qore code to generate the given request message

Implements RestSchemaValidator::AbstractRestSchemaValidator.

## getQoreExampleResponseImpl()

hash<RestQoreExampleCodeInfo> RestSchemaValidator::NullRestSchemaValidator::getQoreExampleResponseImpl | ( | string | method,
|  | string | path,
|  | int | code
| ) |  |

privatevirtual

returns example Qore code for the given response

Parameters

  method | the HTTP method of the original request (case insensitive)
  path | the URI path of the original request
  code | the HTTP response code of the response

Returns
  a RestQoreExampleCodeInfo hash giving example Qore code to generate the given response message

Implements RestSchemaValidator::AbstractRestSchemaValidator.

## getTargetUrlImpl()

string RestSchemaValidator::NullRestSchemaValidator::getTargetUrlImpl | ( |  | ) |

privatevirtual

returns the target URL for the schema

Returns
  the target URL for the schema

Exceptions

  MISSING-TARGET-URL | no target URL provided for the schema

Implements RestSchemaValidator::AbstractRestSchemaValidator.

## parseRequestImpl()

hash<RestRequestServerInfo> RestSchemaValidator::NullRestSchemaValidator::parseRequestImpl | ( | string | method,
|  | string | path,
|  | *data | http_body,
|  | reference< hash > | headers
| ) |  |

privatevirtual

processes and parses a client request and returns the deserialized message body (if any)

Parameters

  method | the HTTP method (case-insensitive)
  path | the URI path with any query arguments
  http_body | the serialized message body
  headers | a reference to the hash of HTTP headers received; any default header values to be assumed by the server for the request will be added here

Returns
  a RestRequestServerInfo hash of request information

Exceptions

  DESERIALIZATION-ERROR | the request body could not be deserialized, results in a `400 Bad Request` response returned to the caller
  SCHEMA-VALIDATION-ERROR | this exception should be thrown if there is a validation error in the request so that a `400 Bad Request` response can be returned to the caller
  INVALID-METHOD | invalid HTTP method for the request; the `arg` argument should have a list of acceptable HTTP methods for this request

Implements RestSchemaValidator::AbstractRestSchemaValidator.

## parseResponseImpl()

hash<RestResponseClientInfo> RestSchemaValidator::NullRestSchemaValidator::parseResponseImpl | ( | string | method,
|  | string | path,
|  | int | code,
|  | *data | response_body,
|  | hash | hdr
| ) |  |

privatevirtual

parses and validates the response from the server and returns a hash of the processed info

Parameters

  method | the HTTP method (case insensitive)
  path | the URI path of the original request (without any query arguments)
  code | the HTTP response code
  response_body | the HTTP response body data (if any)
  hdr | as hash of HTTP headers received

Exceptions

  DESERIALIZATION-ERROR | the request body could not be deserialized or had an invalid `Content-Type`

Implements RestSchemaValidator::AbstractRestSchemaValidator.

## processRequestImpl()

hash<RestRequestClientInfo> RestSchemaValidator::NullRestSchemaValidator::processRequestImpl | ( | string | method,
|  | string | path,
|  | auto | body,
|  | *hash | headers,
|  | *softlist< string > | content_types
| ) |  |

privatevirtual

processes a client-side REST request and returns a hash that can be used to make the outgoing client-side HTTP request

Parameters

  method | the HTTP method (case-insensitive)
  path | the URI path with any query arguments
  body | the unserialized message body data
  headers | any headers to include in the request; note that the `Content-Type` header should not be sent here as it will be overridden when the message is serialized
  content_types | the desired MIME types for serialization in order of preference; if none are usable then an exception is thrown

Returns
  a RestRequestClientInfo hash with information about the request

Exceptions

  SERIALIZATION-ERROR | unsupported message body MIME type requested or missing serialization module

Implements RestSchemaValidator::AbstractRestSchemaValidator.

## processResponseImpl()

hash<HttpResponseInfo> RestSchemaValidator::NullRestSchemaValidator::processResponseImpl | ( | string | method,
|  | string | path,
|  | int | code,
|  | auto | response_body,
|  | *hash | headers,
|  | *softlist< string > | content_types
| ) |  |

private

processes a REST response with a serialized message body, validates any response data against schema definitions if possible

Parameters

  method | the HTTP method of the original request
  path | the URI path of the original request (without query arguments)
  code | the HTTP response code
  response_body | the response body data (if any)
  headers | HTTP headers to include in the response
  content_types | the desired MIME types for serialization in order of preference; if none are usable then an exception is thrown; if this argument is not present, then json is preferred over yaml

Returns
  an HttpResponseInfo hash for the response

Exceptions

  ACCEPT-ERROR | the response body could not be serialized because the client does not accept a supported type
  SERIALIZATION-ERROR | the response body could not be serialized due to an error

Note
  <a href="http://www.w3.org/Protocols/rfc2616/rfc2616-sec14.html>RFC 2616 section 14</a>: If an Accept header field is present, and if the server cannot send a response which is acceptable according to the combined Accept field value, then the server SHOULD send a 406 (not acceptable) response. To ensure this happens, if an Accept error of this nature occurs in this call, an \c "ACCEPT-ERROR" must be thrown

## setBasePathImpl()

RestSchemaValidator::NullRestSchemaValidator::setBasePathImpl | ( | string | basePath | ) |

virtual

overrides the basePath value

Parameters

  basePath | the new base path value; use an empty string here to clear the basePath

Implements RestSchemaValidator::AbstractRestSchemaValidator.